//
//  CicyxView.m
//  CIcyxView
//
//  Created by Amin Negm-Awad on Mi.,07.07.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "CicyxView.h"

const CGFloat border = 0.1;

@implementation CicyxView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)strokeHorizontalLineFrom:(CGFloat)minX
                           width:(CGFloat)width
                              at:(CGFloat)y
                       transform:(NSAffineTransform*)transform
{
   NSBezierPath* path = [NSBezierPath bezierPath]; 
   [path setLineWidth:0.0]; 
   [path moveToPoint:NSMakePoint( minX, y )]; 
   [path relativeLineToPoint:NSMakePoint( width, 0.0 )]; 
   [path transformUsingAffineTransform:transform];
   [path stroke];
}

- (void)drawRect:(NSRect)dirtyRect {
   // Hintergrund weiß 
   [[NSColor whiteColor] set];
   NSRectFill( dirtyRect );

   // Berechne Zeichenfläche
   NSRect drawRect = self.bounds; drawRect = NSInsetRect( self.bounds,
   NSWidth( drawRect ) * border, NSHeight( drawRect ) * border );

   // Hole Standardfont in Standardgröße
   NSFont* font = [NSFont userFontOfSize:0.0];

   // Hole die wichtigsten Font-Eigenschaften 
   CGFloat ascender	= [font ascender];
   CGFloat descender = [font descender];
   CGFloat fontHeight = ascender - descender;
   CGFloat capHeight = [font capHeight];
   CGFloat xHeight	= [font xHeight];
   
   // Hole die Glyphen 
   NSGlyph	glyphs[5]; 
   glyphs[0] = [font glyphWithName:@"C"]; 
   glyphs[1] = [font glyphWithName:@"I"]; 
   glyphs[2] = [font glyphWithName:@"c"]; 
   glyphs[3] = [font glyphWithName:@"y"];
   glyphs[4] = [font glyphWithName:@"x"];
   
   // Erzeuge einen Pfad für den Text 
   NSBezierPath* glyphsPath = [NSBezierPath bezierPath]; 
   [glyphsPath moveToPoint:NSMakePoint( 0.0, 0.0 )];
   [glyphsPath appendBezierPathWithGlyphs:glyphs 
                                    count:5 
                                   inFont:font];
   CGFloat minX = NSMinX( [glyphsPath bounds] );
   CGFloat width = NSWidth( [glyphsPath bounds] );
   
   // Erstelle eine Transformation, die in der Höhe passt. 
   NSAffineTransform* transform = [NSAffineTransform transform];
   [transform translateXBy:0.0 yBy:NSMinY( drawRect )];
   CGFloat scale = NSHeight( drawRect ) / fontHeight;
   [transform scaleXBy:scale yBy:scale];
   [transform translateXBy:0.0 yBy:-descender];
   [glyphsPath transformUsingAffineTransform:transform];
   
   // Zeichne die Bounds des Bezierpfades
   [[NSColor lightGrayColor] set];
   NSRectFill( [glyphsPath bounds] );
   
   // Zeichne die Glyphen als Bezierpfade 
   [glyphsPath setLineWidth:0.0];
   [[NSColor whiteColor] set];
   [glyphsPath fill];
   [[NSColor blackColor] set];
   [glyphsPath stroke];
   
   // Zeichne Metriken
   [[NSColor blackColor] set];
   [self strokeHorizontalLineFrom:minX width:width at:0.0
                        transform:transform];
   [self strokeHorizontalLineFrom:minX width:width at:xHeight
                        transform:transform];
   [self strokeHorizontalLineFrom:minX width:width at:capHeight
                        transform:transform]; 
   [self strokeHorizontalLineFrom:minX width:width at:ascender
                        transform:transform];
   [self strokeHorizontalLineFrom:minX width:width at:descender
                        transform:transform];
}
@end
