//
//  CardStackView.m
//  Card Game
//
//  Created by Amin Negm-Awad on Mi.,23.06.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "CardStackView.h"

static const float edgeRadius = 0.1;

@implementation CardStackView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawCardFaceWithSuit:(NSUInteger)suit 
                       value:(NSUInteger)value
                      inRect:(NSRect)rect
{
   // Mittelpunkt des Kartenrechteckes 
   NSPoint center; 
   center = NSMakePoint( NSMidX( rect ), NSMidY( rect ));
   
   // Vier Punkte darum, an den Spitzen eines Karos
   NSPoint left 
   = NSMakePoint(center.x - NSWidth( rect ) * 0.2, center.y );
   NSPoint top
   = NSMakePoint(center.x, center.y + NSWidth( rect ) * 0.2 );
   NSPoint right
   = NSMakePoint(center.x + NSWidth( rect ) * 0.2, center.y );
   NSPoint bottom
   = NSMakePoint(center.x, center.y - NSWidth( rect ) * 0.2 );
   
   // Leere Instanz erzeugen 
   NSBezierPath* path = [NSBezierPath bezierPath];
   
   // Startpunkt festlegen 
   [path moveToPoint:left];
   // Eine gerade Linie zum oberen Punkt 
   [path lineToPoint:top];
   
   // Ein Viertelkreis zum rechten Punkt 
   [path appendBezierPathWithArcFromPoint:center
                                  toPoint:right 
                                   radius:NSWidth( rect ) * 0.2];
   
   // Eine Bezierkurve zum unteren Punkt 
   [path  curveToPoint:bottom
         controlPoint1:NSMakePoint( right.x - 12, right.y ) 
         controlPoint2:NSMakePoint( bottom.x, bottom.y + 12 )];
   
   // schliessen 
   [path closePath];
   [[NSColor redColor] setFill]; 
   [path fill];
}

- (void)drawRect:(NSRect)dirtyRect {
   // Umrandung zeichnen 
   NSRect cardRect = NSInsetRect( [self bounds], 0.5, 0.5 ); 

   CGFloat radius = NSWidth( cardRect ) * edgeRadius;
   
   NSBezierPath* path 
   = [NSBezierPath bezierPathWithRoundedRect:cardRect
                                     xRadius:radius 
                                     yRadius:radius];
   [[NSColor whiteColor] setFill];
   [path fill];
   [[NSColor blackColor] setStroke];
   [path stroke];
   
   [self drawCardFaceWithSuit:0 value:1 inRect:cardRect];
}
@end
