//
//  CardStackView.m
//  Card Game
//
//  Created by Amin Negm-Awad on Mi.,23.06.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "CardStackView.h"
#import "BezierPathCardsAddition.h"

static const float edgeRadius = 0.1;

@implementation CardStackView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawCardFaceWithSuit:(NSUInteger)suit 
                       value:(NSUInteger)value
                      inRect:(NSRect)rect
{
   // Mittelpunkt des Kartenrechteckes 
   NSPoint center; 
   center = NSMakePoint( NSMidX( rect ), NSMidY( rect ));
   
   NSBezierPath* path = [NSBezierPath bezierPath];
   
   [path moveToPoint:center]; 
   [path appendBezierPathForSuit:0]; 
   [path appendBezierPathForValue:1]; 
   if( suit < 2 ) {
      [[NSColor redColor] set]; 
   } else {
      [[NSColor blackColor] set];
   }
   [path fill];
}

- (void)drawRect:(NSRect)dirtyRect {
   // Umrandung zeichnen 
   NSRect cardRect = NSInsetRect( [self bounds], 0.5, 0.5 ); 

   CGFloat radius = NSWidth( cardRect ) * edgeRadius;
   
   NSBezierPath* path 
   = [NSBezierPath bezierPathWithRoundedRect:cardRect
                                     xRadius:radius 
                                     yRadius:radius];
   [[NSColor whiteColor] setFill];
   [path fill];
   [[NSColor blackColor] setStroke];
   [path stroke];
   
   [self drawCardFaceWithSuit:0 value:1 inRect:cardRect];
   
   NSImage* image = [NSImage imageNamed:@"Bild"];
   [image drawInRect:NSMakeRect(10.0, 10.0, 100.0, 100.0 )
            fromRect:NSZeroRect
           operation:NSCompositeSourceOver 
            fraction:1.0];
}
@end
