//
//  CardStackView.m
//  Card Game
//
//  Created by Amin Negm-Awad on Mi.,23.06.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "CardStackView.h"
#import "BezierPathCardsAddition.h"

static const float edgeRadius = 0.1;

@implementation CardStackView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawCardFaceWithSuit:(NSUInteger)suit 
                       value:(NSUInteger)value
                      inRect:(NSRect)rect
{
   // Mittelpunkt des Kartenrechteckes 
   NSPoint center; 
   center = NSMakePoint( NSMidX( rect ), NSMidY( rect ));
   
   NSBezierPath* path = [NSBezierPath bezierPath];
   
   [path moveToPoint:center]; 
   [path appendBezierPathForSuit:0]; 
   [path appendBezierPathForValue:1]; 
   if( suit < 2 ) {
      [[NSColor redColor] set]; 
   } else {
      [[NSColor blackColor] set];
   }
   [path fill];
}

- (void)drawRect:(NSRect)dirtyRect {
   // Umrandung zeichnen 
   NSRect cardRect = NSInsetRect( [self bounds], 0.5, 0.5 ); 

   CGFloat radius = NSWidth( cardRect ) * edgeRadius;
   
   NSBezierPath* path 
   = [NSBezierPath bezierPathWithRoundedRect:cardRect
                                     xRadius:radius 
                                     yRadius:radius];
   [[NSColor whiteColor] setFill];
   [path fill];
   [[NSColor blackColor] setStroke];
   [path stroke];
   
   [self drawCardFaceWithSuit:0 value:1 inRect:cardRect];
}

- (IBAction)createTiff:(id)sender {
   NSSize imageSize = [self bounds].size; 
   NSRect cardRect = NSInsetRect( [self bounds], 0.5, 0.5 ); 
   NSImage* image
   = [[[NSImage alloc] initWithSize:imageSize] autorelease]; 
   [image lockFocus]; 
   NSFrameRect( cardRect ); 
   [self drawCardFaceWithSuit:2 value:0 inRect:cardRect]; 
   [image unlockFocus];
   NSData* tiff = [image TIFFRepresentation]; 
   NSString* path = @"~/Desktop/Bild.tiff"; 
   path = [path stringByExpandingTildeInPath]; 
   [tiff writeToFile:path atomically:YES];
}
@end
