//
//  ContainerView.m
//  Card Game
//
//  Created by Amin Negm-Awad on Fr.,13.08.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "ContainerView.h"

static const CGFloat border = 8.0;

@implementation ContainerView
- (BOOL)acceptsFirstResponder { return YES; }

- (IBAction)print:(id)sender {
   NSPrintOperation* operation 
   = [NSPrintOperation printOperationWithView:self];
   [operation runOperation];  
}

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)addSubview:(NSView*)subview {
   NSRect subviewFrame = subview.frame;
   
   // Die Lage des neuen Views ergibt sich aus dem Container:
   subviewFrame.origin.x = border;
   subviewFrame.origin.y = NSHeight( self.bounds );
   [subview setFrameOrigin:subviewFrame.origin];
   
   // Die Groesse des Containers anpassen
   NSSize containerSize = self.frame.size;
   containerSize.height += subviewFrame.size.height + border;
   CGFloat minWidth = subviewFrame.size.width + border + border;
   if( containerSize.width < minWidth ) {
      containerSize.width = minWidth; [self setFrameSize:containerSize];
   }
   [self setFrameSize:containerSize];
   
   // Das neue View dem Container hinzufuegen
   [super addSubview:subview];
}

- (void)drawRect:(NSRect)dirtyRect {
   [[NSColor darkGrayColor] setFill];
   NSFrameRect( [self bounds] );
   
   // Schatten um die Subviews, damit es schoener aussieht 
   for( NSView* subview in [self subviews] ) {
      NSShadow* shadow = [[[NSShadow alloc] init] autorelease]; 
      [shadow setShadowBlurRadius:border];
      [shadow set];
      NSRectFill( [subview frame] );
   }
}

- (BOOL)knowsPageRange:(NSRangePointer)range 
{ 
   (*range).location = 1;
   (*range).length = [[self subviews] count];
   return YES;
}

- (NSRect)rectForPage:(NSInteger)page 
{ 
   return [[[self subviews] objectAtIndex:page-1] frame];
}
@end
