//  TableBaizeView.h
//  Card Game
//
//  Created by Amin Negm-Awad
//  Copyright [co coa:ding] 2009. All rights reserved.

#import <Cocoa/Cocoa.h>

@class CardStackView;
@class TableBaizeView;

#pragma mark Data-Source-Protokoll
extern const NSUInteger playerStacksMinIndex;
extern const NSUInteger playerStacksCount;
extern const NSUInteger depotStackIndex;
extern const NSUInteger targetStackIndex;

@protocol TableBaizeViewDataSource
- (id)tableBaizeView:(TableBaizeView*)view 
      stackWithIndex:(NSUInteger)index;

- (NSUInteger)     tableBaizeView:(TableBaizeView*)view 
              countOfCardsOnStack:(id)stack;

- (NSUInteger)                tableBaizeView:(TableBaizeView*)view 
             countOfNonDisclosedCardsOnStack:(id)stack;

- (id)tableBaizeView:(TableBaizeView*)view
       cardWithIndex:(NSUInteger)index
             onStack:(id)stack;
- (NSUInteger)tableBaizeView:(TableBaizeView*)view 
                 valueOfCard:(id)card;

- (NSUInteger)tableBaizeView:(TableBaizeView*)view 
                  suitOfCard:(id)card;
@end

@interface TableBaizeView : NSView {
   NSMutableArray* playerViews;
   CardStackView*  depotView;
   CardStackView*  targetView;
   id<TableBaizeViewDataSource> dataSource;
}
@property( assign ) id<TableBaizeViewDataSource> dataSource;

- (void)reloadDataForStackWithIndex:(NSUInteger)stackIndex;
- (void)reloadData;
@end
