//
//  CardStackView.h
//  Card Game
//
//  Created by Amin Negm-Awad
//  Copyright 2009 [co coa:ding]. All rights reserved.

#import <Cocoa/Cocoa.h>


@interface CardStackView : NSView {
   NSUInteger      countOfNonDisclosedCards;
   NSMutableArray* cards;
   NSRectEdge      alignment;
   
   NSIndexSet* selectedCardsIndices;
   NSInteger   draggedCardsCount;
}
@property NSUInteger countOfNonDisclosedCards;
@property( readonly ) NSUInteger cardsCount;

// Property cards (to-many relationship)
- (NSArray*)cards;
- (void)setCards:(NSArray*)cards;
- (void)   insertCards:(NSArray*)cards 
      inCardsAtIndexex:(NSIndexSet*)indexes;
- (void)removeCardsAtIndexes:(NSIndexSet*)indexes;
- (void)replaceCardsAtIndexes:(NSIndexSet*)indexes
                    withCards:(NSArray*)cards;

@property NSRectEdge alignment;
@property NSInteger draggedCardsCount;
@property( copy ) NSIndexSet* selectedCardsIndices;

+ (CGFloat)cardHeightForWidth:(CGFloat)width;
+ (CGFloat)cardWidthForHeight:(CGFloat)height;
@end
