//
//  BezierPathCardsAddition.m
//  Card Game
//
//  Created by Amin Negm-Awad
//  Copyright 2009 [co coa:ding]. All rights reserved.

#import "BezierPathCardsAddition.h"

@implementation NSBezierPath( BezierPathCardsAddition )
- (void)appendBezierPathForSuit:(NSUInteger)suit
{
   
   NSFont* font;
   font = [NSFont fontWithName:@"Apple Symbols" size:40]; 
   
   switch( suit ) {
      case 0:
         [self appendBezierPathWithGlyph:389 inFont:font]; 
         break;
      case 1:
         [self appendBezierPathWithGlyph:388 inFont:font];
         break;
      case 2:
         [self appendBezierPathWithGlyph:383 inFont:font];
         break;
      case 3:
         [self appendBezierPathWithGlyph:386 inFont:font];
         break;
   }
}

- (void)appendBezierPathForValue:(NSUInteger)index
{
   NSFont* font;
   font = [NSFont fontWithName:@"Helvetica" size:40];   
   
   // Reihenfolge ist: 0 A 2 3 4 5 6 7 8 9 1 B D K
   switch( index ) {
      case 1: // A
         [self appendBezierPathWithGlyph:36 inFont:font];
         break;
      case 10: // 1
         [self appendBezierPathWithGlyph:20 inFont:font];
         [self appendBezierPathWithGlyph:19 inFont:font];
         break;
      case 11: // B
         [self appendBezierPathWithGlyph:37 inFont:font];
         break;
      case 12: // D
         [self appendBezierPathWithGlyph:39 inFont:font];
         break;
      case 13: // K
         [self appendBezierPathWithGlyph:46 inFont:font];
         break;
      default: // 2 3 4 5 6 7 8 9
         [self appendBezierPathWithGlyph:19+index inFont:font];
         break;
   }   
}

- (void)transformToLocation:(NSPoint)location 
                     height:(CGFloat)height
{
   NSAffineTransform* transform = [NSAffineTransform transform];
   [transform translateXBy:location.x yBy:location.y];
   CGFloat factor = height / NSHeight( [self bounds] );
   [transform scaleXBy:factor yBy:factor]; 
   [self transformUsingAffineTransform:transform];
}

@end
