//
//  Card.m
//  Card Game
//
//  Created by Amin Negm-Awad on Di,15.09.09.
//  Copyright 2009 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "Card.h"
#import "CardStack.h"

@implementation Card
@synthesize value, suit;

- (CardStack*)stack { return stack; }
- (void)setStack:(CardStack*)newStack {
   // nichts aendert sich
   if( newStack == stack ) {
      return;
   }
   
   // Ist die Karte zugedeckt
   if( self.disclosed == NO ) {      
      // Falls Sie sich in einem Stack befindet, muss dessen 
      // Zaehler herabgesetzt werden.
      if( stack ) {
         self.stack.countOfNonDisclosedCards--;
      }
      
      // Wird sie einem neuen Stack hinzugefuegt, so muss der 
      // Zaehler erhoeht werden
      if( newStack ) {
         newStack.countOfNonDisclosedCards++;
      }
   }
   
   stack = newStack; // Assign-Setter!
}

- (BOOL)disclosed { return disclosed; }
- (void)setDisclosed:(BOOL)newDisclosed
{
   // Befindet sich die Karte in einem Stack
   if( self.stack ) {
      // Wird die Karte aufgedeckt
      if( (disclosed == NO) && (newDisclosed == YES) ) {
         self.stack.countOfNonDisclosedCards--;
         
         // zugedeckt?
      } else if( (disclosed == YES) && (newDisclosed == NO) ) {
         self.stack.countOfNonDisclosedCards++;
      }
   }
   
   disclosed = newDisclosed;
}

- (NSString*)description 
{
   NSString* text;
   
   switch( [self.suit unsignedIntegerValue] ) {
      case 0:
         text = [NSString stringWithFormat:@"%C", 0x2662];
         break;
         
      case 1:
         text = [NSString stringWithFormat:@"%C", 0x2661];
         break;
         
      case 2:
         text = [NSString stringWithFormat:@"%C", 0x2660];
         break;
         
      case 3:
         text = [NSString stringWithFormat:@"%C", 0x2663];
         break;
         
      default:
         text = @"?";
         break;
   }
   
   text = [NSString stringWithFormat:@"%@%d", text, self.value];
   
   if( self.disclosed ) {
      text = [text stringByAppendingString:@"+"];
   } else {
      text = [text stringByAppendingString:@"-"];
   }
   return text;
}

- (id)init {
   self = [super init];
   
   if( self ) {
      self.value = 0;
      self.suit = [NSNumber numberWithInteger:0];
      self.disclosed = NO;
   }
   
   return self;
}

- (void) dealloc
{
   self.value = 0;
   self.suit = nil;
   self.disclosed = NO;
   
   [super dealloc];
}
@end
