//
//  Card.m
//  Card Game
//
//  Created by Amin Negm-Awad on Di,15.09.09.
//  Copyright 2009 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "Card.h"
#import "CardStack.h"

@implementation Card
@synthesize value, suit;
@synthesize stack;

- (BOOL)disclosed { return disclosed; }
- (void)setDisclosed:(BOOL)newDisclosed
{
   // Befindet sich die Klasse in einem Stack und haben wir 
   // inhaltlich eine Aenderung 
   BOOL change;
   change = (newDisclosed != disclosed) && (self.stack != nil);
   NSString* key = @"countOfNonDisclosedCards";
   
   // Aenderung ankuendigen
   if( change )  {
      [self.stack willChangeValueForKey:key];
   }
   
   // Aenderung durchführen   
   disclosed = newDisclosed;
   
   // Aenderung abschliessen
   if( change )  {
      [self.stack didChangeValueForKey:key];
   }   
}

- (NSString*)description 
{
   NSString* text;
   
   switch( [self.suit unsignedIntegerValue] ) {
      case 0:
         text = [NSString stringWithFormat:@"%C", 0x2662];
         break;
         
      case 1:
         text = [NSString stringWithFormat:@"%C", 0x2661];
         break;
         
      case 2:
         text = [NSString stringWithFormat:@"%C", 0x2660];
         break;
         
      case 3:
         text = [NSString stringWithFormat:@"%C", 0x2663];
         break;
         
      default:
         text = @"?";
         break;
   }
   
   text = [NSString stringWithFormat:@"%@%d", text, self.value];
   
   if( self.disclosed ) {
      text = [text stringByAppendingString:@"+"];
   } else {
      text = [text stringByAppendingString:@"-"];
   }
   return text;
}

- (id)init {
   self = [super init];
   
   if( self ) {
      self.value = 0;
      self.suit = [NSNumber numberWithInteger:0];
      self.disclosed = NO;
   }
   
   return self;
}

- (void) dealloc
{
   self.value = 0;
   self.suit = nil;
   self.disclosed = NO;
   
   [super dealloc];
}
@end
