//  TableBaizeView.h
//  Card Game
//
//  Created by Amin Negm-Awad
//  Copyright [co coa:ding] 2009. All rights reserved.

#import <Cocoa/Cocoa.h>

@class CardStackView;
@class TableBaizeView;

#pragma mark Data-Source-Protokoll
extern const NSUInteger playerStacksMinIndex;
extern const NSUInteger playerStacksCount;
extern const NSUInteger depotStackIndex;
extern const NSUInteger targetStackIndex;

extern NSString* const targetDisclosedCardsBinding;
extern NSString* const depotDisclosedCardsBinding;
extern NSString* const depotNonDisclosedCardsCountBinding;
extern NSString* const playerNDisclosedCardsBinding;
extern NSString* const playersNonDisclosedCardsCountBinding;

@class TableBaizeView;

@protocol TableBaizeViewDelegate
@optional

// Aufdecken
- (BOOL)              tableBaizeView:(TableBaizeView*)view
        discloseCardOnStackWithIndex:(NSUInteger)index;

// Geben
- (void)tableBaizeViewDealCards:(TableBaizeView*)view;

// Ziehen
- (BOOL)        tableBaizeView:(TableBaizeView*)view
        shouldDragCardsAtIndex:(NSUInteger)cardIndex
            fromStackWithIndex:(NSUInteger)stackIndex;

- (BOOL)    tableBaizeView:(TableBaizeView*)view
         writeCardsAtIndex:(NSUInteger)cardIndex
        fromStackWithIndex:(NSUInteger)stackIndex
              toPasteboard:(NSPasteboard*)pasteboard;

- (BOOL)    tableBaizeView:(TableBaizeView*)view
        shouldValidateDrop:(id<NSDraggingInfo>)dragInfo
          onStackWithIndex:(NSUInteger)stackIndex;

- (void)  tableBaizeView:(TableBaizeView*)view
             performDrop:(id<NSDraggingInfo>)dragInfo
        onStackWithIndex:(NSUInteger)stackIndex;

- (void)    tableBaizeView:(TableBaizeView*)view
        removeCardsAtIndex:(NSUInteger)index
          onStackWithIndex:(NSUInteger)stackIndex;
@end

@interface TableBaizeView : NSView {
   NSMutableArray* playerViews;
   CardStackView*  depotView;
   CardStackView*  targetView;
   id<TableBaizeViewDelegate> delegate;
}
@property( assign ) id<TableBaizeViewDelegate> delegate;

- (CardStackView*)viewWithStackIndex:(NSUInteger)index;
- (void)setValueKeyPath:(NSString*)valueKeyPath 
         andSuitKeyPath:(NSString*)suitKeyPath;

// Delegating
- (BOOL)allowsDraggingFromCardStackView:(CardStackView*)view
                                atIndex:(NSUInteger)index;
- (void)          fillPasteboard:(NSPasteboard*)pasteboard 
        withCardsOfCardStackView:(CardStackView*)view
                         atIndex:(NSUInteger)index;
@end
