//
//  CardStack.m
//  Card Game
//
//  Created by Amin Negm-Awad on Di,15.09.09.
//  Copyright 2009 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "CardStack.h"
#import "Card.h"

@implementation CardStack
- (NSUInteger)countOfNonDisclosedCards
{
   NSUInteger index = 0;
   for( index = 0; index < [self.cards count]; index++ ) {
      if( [[self.cards objectAtIndex:index] disclosed] == YES ) {
         break;
      }
   }
   
   return index;
}

- (NSArray*)cards { return cards; }
- (void)setCards:(NSArray*)value
{
   if( value != cards ) {
      NSEnumerator* cardsEnum;
   
      // alle alten Karte aus dem Stack entfernen
      cardsEnum = [self.cards objectEnumerator];
      for( Card* card in cardsEnum ) {
         card.stack = nil;
      }
   
      // Neue Karten setzen
      cardsEnum = [value objectEnumerator];
      for( Card* card in cardsEnum ) {
         card.stack = self;
      }
      
      [cards release];
      cards = [value copy];
   }
}

-(id)init 
{
   self = [super init];
   
   if( self ) {
      self.cards = [NSArray array];
   }
   
   return self;
}

- (void) dealloc
{
   self.cards = nil;
   [super dealloc];
}

+ (NSSet*)keyPathsForValuesAffectingCountOfNonDisclosedCards
{
   return [NSSet setWithObject:@"cards"];
}
@end
