//
//  FileHandleAppDelegate.m
//  FileHandle
//
//  Created by Amin Negm-Awad on Di.,13.07.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "FileHandleAppDelegate.h"

@implementation FileHandleAppDelegate
@synthesize window;
@synthesize data; 

- (void)receiveData:(NSNotification*)notification
{
   NSDictionary* info = [notification userInfo];
   NSData* newData 
   = [info valueForKey:@"NSFileHandleNotificationDataItem"]; 
   if( [newData length] == 0 ) {
      NSLog( @"Ende der Verbindung" ); return;
   }
   
   [readProgressView incrementBy:[newData length]];
   [[self data] appendData:data];
   [[notification object] readInBackgroundAndNotify];
}

- (IBAction)readFile:(id)sender
{
   NSString* path 
   = [@"~/Desktop/big" stringByExpandingTildeInPath];
   
   NSFileManager* manager = [NSFileManager defaultManager]; 
   
   NSError* error = nil;
   NSDictionary* attribs
   = [manager attributesOfItemAtPath:path error:&error]; 
    NSLog( @"Attribs: %@", attribs );
   
   // Starte lesen 
   long size = [[attribs objectForKey:NSFileSize] longValue];
   [readProgressView setMaxValue:size];
   [readProgressView setDoubleValue:0.0];
   
   // Starte lesen
   NSFileHandle* fileHandle
   = [NSFileHandle fileHandleForReadingAtPath:path];
   NSNotificationCenter* center 
   = [NSNotificationCenter defaultCenter];
   [center addObserver:self 
              selector:@selector( receiveData: )
                  name:NSFileHandleReadCompletionNotification 
                object:fileHandle];
   [fileHandle readInBackgroundAndNotify];
}


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	// Insert code here to initialize your application 
}

- (id)init 
{
   self= [super init];
   if( self ) {
      self.data = [NSMutableData data];
   } 
   return self;
}

- (void)dealloc {
   self.data = nil; [super dealloc];
}

@end
