//
//  CircleTextView.m
//  LayoutStack
//
//  Created by Amin Negm-Awad on Do.,08.07.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "CircleTextView.h"


@implementation CircleTextView
- (NSRect)circleRect 
{
   NSRect circleRect = self.bounds;
   
   if( NSWidth( circleRect ) > NSHeight( circleRect ) ) { 
      circleRect.size.width = circleRect.size.height;
      circleRect.origin.x 
      = (NSWidth( self.bounds ) - NSWidth( circleRect )) / 2;
   } else { 
      circleRect.size.height = circleRect.size.width;
      circleRect.origin.y 
      = (NSHeight( self.bounds ) - NSHeight( circleRect )) / 2;
   } 
   circleRect = NSInsetRect( circleRect,
                             NSWidth( circleRect ) * 0.1, 
                             NSHeight( circleRect ) * 0.1 );
   return circleRect;
}

- (id)initWithFrame:(NSRect)frame textContainer:container {
    self = [super initWithFrame:frame textContainer:container];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawRect:(NSRect)dirtyRect {
   NSLog( @"gesagt, gemalt" );
   [super drawRect:dirtyRect]; 
   NSRect circleRect = [self circleRect];
   NSBezierPath* circle 
   = [NSBezierPath bezierPathWithOvalInRect:circleRect];
   [[NSColor blueColor] setStroke]; 
   [circle stroke];
}

@end
