//
//  LayoutStackAppDelegate.m
//  LayoutStack
//
//  Created by Amin Negm-Awad on Mi.,07.07.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "LayoutStackAppDelegate.h"

#import "CircleTextView.h"
#import "CircleTextContainer.h"

@implementation LayoutStackAppDelegate

@synthesize window;
@synthesize storage;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
   // Stufe 1: Textstorage erzeugen 
   self.storage = [[[NSTextStorage alloc] init] autorelease];
   
   // Stufe 2: LayoutManager erzeugen und an den Storage hängen 
   NSLayoutManager* layoutManager 
   = [[[NSLayoutManager alloc] init] autorelease];
   [self.storage addLayoutManager:layoutManager];
   
   // Stufe 3: Text-Container, der als Fläche ein Rechteck 
   //	in der Größe des Views hat 
   NSRect frame = placeholder.frame; 
   NSTextContainer* container
   = [[[CircleTextContainer alloc] 
                        initWithContainerSize:frame.size]
                        autorelease];
   [container setWidthTracksTextView:YES];
   [container setHeightTracksTextView:YES];
   [layoutManager addTextContainer:container];
   
   // Stufe 4: Ein Textview für die Anzeige in der Größe des 
   //	Containers
   CircleTextView* textView 
   = [[[CircleTextView alloc]
                   initWithFrame:frame textContainer:container]
                   autorelease];
   [textView setAutoresizingMask:[placeholder autoresizingMask]];
   
   // Views Austauschen 
   [[placeholder superview] addSubview:textView];
   [placeholder removeFromSuperview];
}
@end
