//
//  ScrewDisclosure.m
//  Stackspector
//
//  Created by Amin Negm-Awad on Do.,08.07.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "ScrewDisclosure.h"


@implementation ScrewDisclosure
@synthesize disclosedHeight;

- (NSInteger)state { return [self.cell state]; } 
- (void)setState:(NSInteger)value { [self.cell setState:value]; }

- (IBAction)showContent:(id)sender {
   NSSize size = self.frame.size;
   size.height = self.disclosedHeight;
   [self setFrameSize:size];
}

- (IBAction)hideContent:(id)sender {
   NSSize size = self.frame.size;
   size.height = [self.cell cellSize].height;
   [self setFrameSize:size];
}
   
- (id)initWithFrame:(NSRect)frame {
   self = [super initWithFrame:frame];
   if( self ) { 
      NSCell* cell 
      = [[[NSCell alloc]
                  initTextCell:@"123 Cell ist dabei"]
                  autorelease]; 
      [cell setBordered:YES];
      self.cell = cell; 
      self.state = NSOnState; 
      cell.alignment = NSLeftTextAlignment; 
      self.disclosedHeight = frame.size.height;
   } 
   return self;
}
- (void) dealloc {
   self.disclosedHeight = 0.0; 
   [super dealloc];
}
@end
