//
//  StackView.m
//  Stackspector
//
//  Created by Amin Negm-Awad on Fr.,09.07.10.
//  Copyright 2010 Dr. Pribilla Kaldenhoff Negm. All rights reserved.
//

#import "StackView.h"


@implementation StackView
- (void)rearrangeForSubview:(NSView*)control {
   // Von unten nach oben
   CGFloat lowerEdge = -1.0;
   for( NSView* aboveView in self.subviews ) {
      if( lowerEdge < 0.0 ) { 
         if( aboveView == control ) {
            lowerEdge = NSMaxY( control.frame );
         }
      } else {
         NSRect frame = aboveView.frame;
         frame.origin.y = lowerEdge;
         aboveView.frame = frame;
         lowerEdge = NSMaxY( frame );
      }
   }  
   NSRect frame = self.frame;
   frame.size.height = lowerEdge;
   self.frame = frame;
}
   
- (void)awakeFromNib {
   // subviews sortieren und anordnen
   CGFloat lowerEdge = 0.0;
   for( NSView* control in self.subviews ) {
      NSRect frame = control.frame;
      frame.origin.x = 0.0;
      frame.origin.y = lowerEdge;
      frame.size.width = self.frame.size.width;
      control.frame = frame;
      lowerEdge += frame.size.height-1.0;

      // Autoresizing ist festgelegt: X-verbreiten und Y-unten 
      NSUInteger autoresizingMask; 
      autoresizingMask = NSViewWidthSizable | NSViewMaxYMargin;
      [control setAutoresizingMask:autoresizingMask];
   }
   
   NSRect frame = self.frame;
   frame.size.height = lowerEdge+1.0;
   self.frame = frame;
}

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}
@end
